(function (_, kotlin_kotlin, kotlin_org_jetbrains_kotlinx_kotlinx_datetime) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var toString = kotlin_kotlin.$_$.q8;
  var protoOf = kotlin_kotlin.$_$.o8;
  var getStringHashCode = kotlin_kotlin.$_$.n7;
  var hashCode = kotlin_kotlin.$_$.o7;
  var THROW_CCE = kotlin_kotlin.$_$.xb;
  var equals = kotlin_kotlin.$_$.i7;
  var initMetadataForClass = kotlin_kotlin.$_$.p7;
  var plus = kotlin_kotlin.$_$.n5;
  var emptyMap = kotlin_kotlin.$_$.m4;
  var VOID = kotlin_kotlin.$_$.g;
  var split = kotlin_kotlin.$_$.va;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.l;
  var joinToString = kotlin_kotlin.$_$.w4;
  var reversed = kotlin_kotlin.$_$.u5;
  var Companion_getInstance = kotlin_org_jetbrains_kotlinx_kotlinx_datetime.$_$.b;
  var last = kotlin_kotlin.$_$.c5;
  var Unit_instance = kotlin_kotlin.$_$.g3;
  var isBlank = kotlin_kotlin.$_$.ga;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.d4;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.k;
  var charSequenceLength = kotlin_kotlin.$_$.f7;
  var listOf = kotlin_kotlin.$_$.g5;
  var isCharSequence = kotlin_kotlin.$_$.z7;
  var trim = kotlin_kotlin.$_$.ib;
  var emptyList = kotlin_kotlin.$_$.l4;
  var listOf_0 = kotlin_kotlin.$_$.f5;
  var plus_0 = kotlin_kotlin.$_$.q5;
  var first = kotlin_kotlin.$_$.p4;
  var copyToArray = kotlin_kotlin.$_$.i4;
  var to = kotlin_kotlin.$_$.vc;
  var json = kotlin_kotlin.$_$.h8;
  var Exception_init_$Create$ = kotlin_kotlin.$_$.z;
  var toList = kotlin_kotlin.$_$.h6;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(CommitRef, 'CommitRef');
  initMetadataForClass(GitAdapter, 'GitAdapter');
  initMetadataForClass(TagRef, 'TagRef');
  //endregion
  function CommitRef(id, authorEmail, committerEmail, dateTime, parents, fullMessage) {
    this.r18_1 = id;
    this.s18_1 = authorEmail;
    this.t18_1 = committerEmail;
    this.u18_1 = dateTime;
    this.v18_1 = parents;
    this.w18_1 = fullMessage;
  }
  protoOf(CommitRef).toString = function () {
    return 'CommitRef(id=' + this.r18_1 + ', authorEmail=' + this.s18_1 + ', committerEmail=' + this.t18_1 + ', dateTime=' + this.u18_1.toString() + ', parents=' + toString(this.v18_1) + ', fullMessage=' + this.w18_1 + ')';
  };
  protoOf(CommitRef).hashCode = function () {
    var result = getStringHashCode(this.r18_1);
    result = imul(result, 31) + getStringHashCode(this.s18_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.t18_1) | 0;
    result = imul(result, 31) + this.u18_1.hashCode() | 0;
    result = imul(result, 31) + hashCode(this.v18_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.w18_1) | 0;
    return result;
  };
  protoOf(CommitRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof CommitRef))
      return false;
    var tmp0_other_with_cast = other instanceof CommitRef ? other : THROW_CCE();
    if (!(this.r18_1 === tmp0_other_with_cast.r18_1))
      return false;
    if (!(this.s18_1 === tmp0_other_with_cast.s18_1))
      return false;
    if (!(this.t18_1 === tmp0_other_with_cast.t18_1))
      return false;
    if (!this.u18_1.equals(tmp0_other_with_cast.u18_1))
      return false;
    if (!equals(this.v18_1, tmp0_other_with_cast.v18_1))
      return false;
    if (!(this.w18_1 === tmp0_other_with_cast.w18_1))
      return false;
    return true;
  };
  function runProcess($this, args, env) {
    return runProcess_0(args, $this.x18_1, plus(env, $this.y18_1));
  }
  function runProcess$default($this, args, env, $super) {
    env = env === VOID ? emptyMap() : env;
    return runProcess($this, args, env);
  }
  function parseTagRefs($this, outputText) {
    // Inline function 'kotlin.collections.mapNotNull' call
    // Inline function 'kotlin.collections.mapNotNullTo' call
    var this_0 = split(outputText, ['\n']);
    var destination = ArrayList_init_$Create$();
    // Inline function 'kotlin.collections.forEach' call
    var tmp0_iterator = this_0.m();
    while (tmp0_iterator.n()) {
      var element = tmp0_iterator.o();
      // Inline function 'kotlin.collections.mapNotNullTo.<anonymous>' call
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseTagRefs.<anonymous>' call
      var commaSplit = split(element, [',']);
      var tmp;
      if (commaSplit.p() >= 3) {
        tmp = new TagRef(joinToString(commaSplit.t1(0, commaSplit.p() - 2 | 0), ''), reversed(commaSplit).q(1), Companion_getInstance().u17(last(commaSplit)));
      } else {
        tmp = null;
      }
      var tmp0_safe_receiver = tmp;
      if (tmp0_safe_receiver == null)
        null;
      else {
        // Inline function 'kotlin.let' call
        // Inline function 'kotlin.contracts.contract' call
        destination.e(tmp0_safe_receiver);
      }
    }
    var output = destination;
    return output;
  }
  function parseLog($this, outputText) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.filter' call
    // Inline function 'kotlin.collections.filterTo' call
    var this_0 = split(outputText, [$this.z18_1 + '\n']);
    var destination = ArrayList_init_$Create$();
    var tmp0_iterator = this_0.m();
    while (tmp0_iterator.n()) {
      var element = tmp0_iterator.o();
      // Inline function 'kotlin.text.isNotBlank' call
      // Inline function 'kotlin.text.isNotBlank' call
      if (!isBlank(element)) {
        destination.e(element);
      }
    }
    // Inline function 'kotlin.collections.mapTo' call
    var destination_0 = ArrayList_init_$Create$_0(collectionSizeOrDefault(destination, 10));
    var tmp0_iterator_0 = destination.m();
    while (tmp0_iterator_0.n()) {
      var item = tmp0_iterator_0.o();
      // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>' call
      var elements = split(item, ['\n']);
      var tmp = elements.q(0);
      var tmp_0 = elements.q(1);
      var tmp_1 = elements.q(2);
      var tmp_2 = Companion_getInstance().u17(elements.q(3));
      // Inline function 'kotlin.collections.filter' call
      // Inline function 'kotlin.collections.filterTo' call
      var this_1 = split(elements.q(4), [' ']);
      var destination_1 = ArrayList_init_$Create$();
      var tmp0_iterator_1 = this_1.m();
      while (tmp0_iterator_1.n()) {
        var element_0 = tmp0_iterator_1.o();
        // Inline function 'com.zegreatrob.tools.adapter.git.GitAdapter.parseLog.<anonymous>.<anonymous>' call
        // Inline function 'kotlin.text.isNotEmpty' call
        if (charSequenceLength(element_0) > 0) {
          destination_1.e(element_0);
        }
      }
      var tmp$ret$8 = new CommitRef(tmp, tmp_0, tmp_1, tmp_2, destination_1, joinToString(elements.t1(5, elements.p()), '\n'));
      destination_0.e(tmp$ret$8);
    }
    return destination_0;
  }
  function GitAdapter(workingDirectory, env) {
    env = env === VOID ? emptyMap() : env;
    this.x18_1 = workingDirectory;
    this.y18_1 = env;
    this.z18_1 = '--------!--------';
    this.a19_1 = '%H%n%ae%n%ce%n%aI%n%P%n%B%n' + this.z18_1;
  }
  protoOf(GitAdapter).b19 = function () {
    // Inline function 'kotlin.text.trim' call
    var this_0 = runProcess$default(this, listOf(['git', '--no-pager', 'rev-parse', 'HEAD']));
    return toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
  };
  protoOf(GitAdapter).c19 = function () {
    return parseTagRefs(this, runProcess$default(this, listOf(['git', '--no-pager', 'tag', '--list', '--sort=-taggerdate', '--format=%(refname:strip=2),%(*objectname),%(creatordate:iso-strict)'])));
  };
  protoOf(GitAdapter).d19 = function () {
    return parseLog(this, runProcess$default(this, listOf(['git', '--no-pager', 'log', '--format=' + this.a19_1])));
  };
  protoOf(GitAdapter).e19 = function (begin, end) {
    return parseLog(this, runProcess$default(this, plus_0(listOf(['git', '--no-pager', 'log', '--format=' + this.a19_1, begin]), !(end == null) ? listOf_0(end) : emptyList())));
  };
  protoOf(GitAdapter).f19 = function (begin, end, $super) {
    end = end === VOID ? null : end;
    return $super === VOID ? this.e19(begin, end) : $super.e19.call(this, begin, end);
  };
  function TagRef(name, commitId, dateTime) {
    this.g19_1 = name;
    this.h19_1 = commitId;
    this.i19_1 = dateTime;
  }
  protoOf(TagRef).toString = function () {
    return 'TagRef(name=' + this.g19_1 + ', commitId=' + this.h19_1 + ', dateTime=' + this.i19_1.toString() + ')';
  };
  protoOf(TagRef).hashCode = function () {
    var result = getStringHashCode(this.g19_1);
    result = imul(result, 31) + getStringHashCode(this.h19_1) | 0;
    result = imul(result, 31) + this.i19_1.hashCode() | 0;
    return result;
  };
  protoOf(TagRef).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TagRef))
      return false;
    var tmp0_other_with_cast = other instanceof TagRef ? other : THROW_CCE();
    if (!(this.g19_1 === tmp0_other_with_cast.g19_1))
      return false;
    if (!(this.h19_1 === tmp0_other_with_cast.h19_1))
      return false;
    if (!this.i19_1.equals(tmp0_other_with_cast.i19_1))
      return false;
    return true;
  };
  function get_childProcess() {
    _init_properties_RunProcess_js_kt__6db8dd();
    return childProcess;
  }
  var childProcess;
  function runProcess_0(args, workingDirectory, env) {
    var tmp;
    if (env === VOID) {
      // Inline function 'kotlin.collections.mapOf' call
      tmp = emptyMap();
    } else {
      tmp = env;
    }
    env = tmp;
    _init_properties_RunProcess_js_kt__6db8dd();
    var program = first(args);
    // Inline function 'kotlin.collections.toTypedArray' call
    var this_0 = args.t1(1, args.p());
    var tmp$ret$1 = copyToArray(this_0);
    var spawn = get_childProcess().spawnSync(program, tmp$ret$1, json([to('cwd', workingDirectory), to('maxBuffer', 10485760), to('env', toJson(env))]));
    if (spawn.status != 0) {
      // Inline function 'kotlin.js.unsafeCast' call
      var tmp0_safe_receiver = spawn.stderr;
      var tmp$ret$2 = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.toString('utf8');
      throw Exception_init_$Create$(tmp$ret$2);
    }
    // Inline function 'kotlin.js.unsafeCast' call
    var tmp1_safe_receiver = spawn.stdout;
    return tmp1_safe_receiver == null ? null : tmp1_safe_receiver.toString('utf8');
  }
  function toJson(_this__u8e3s4) {
    _init_properties_RunProcess_js_kt__6db8dd();
    // Inline function 'kotlin.collections.toTypedArray' call
    var this_0 = toList(_this__u8e3s4);
    var tmp$ret$0 = copyToArray(this_0);
    return json(tmp$ret$0.slice());
  }
  var properties_initialized_RunProcess_js_kt_yehn37;
  function _init_properties_RunProcess_js_kt__6db8dd() {
    if (!properties_initialized_RunProcess_js_kt_yehn37) {
      properties_initialized_RunProcess_js_kt_yehn37 = true;
      childProcess = require('node:child_process');
    }
  }
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = GitAdapter;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./Kotlin-DateTime-library-kotlinx-datetime.js')));

//# sourceMappingURL=tools-git-adapter.js.map
